﻿Imports System.IO

Public Class frm10_5

    ''' <summary>
    ''' フォームロード時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frm10_5_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TreeView1.BeginUpdate()

        '再帰的にTreeViewにフォルダーを追加する
        CreateFolderTree("C:\eclipse", TreeView1.Nodes.Add("C:\").Nodes)

        TreeView1.EndUpdate()
    End Sub

    ''' <summary>
    ''' 指定したフォルダーのサブフォルダーを検索してノードを作成する
    ''' </summary>
    ''' <param name="strFolder"></param>
    ''' <param name="Node"></param>
    ''' <remarks></remarks>
    Private Sub CreateFolderTree(ByVal strFolder As String, ByVal Node As TreeNodeCollection)
        Dim nodeDir As TreeNode = Node.Add(System.IO.Path.GetFileName(strFolder))

        Try
            For Each strDir As String In Directory.GetDirectories(strFolder)
                CreateFolderTree(strDir, nodeDir.Nodes)
            Next
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' ツリービューでフォルダが選択された場合の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TreeView1_BeforeSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewCancelEventArgs) Handles TreeView1.BeforeSelect
        '項目をクリアする
        ListView1.Items.Clear()

        '選択されたノードのフルパスを取得する
        Dim strFullPath As String = e.Node.FullPath


        Dim di As New DirectoryInfo(strFullPath)

        '選択されたフォルダのサブフォルダを取得してリストビューに表示する
        For Each d As DirectoryInfo In di.GetDirectories()
            Dim dirItemx As New ListViewItem

            dirItemx.Text = d.Name
            ListView1.Items.Add(dirItemx)
        Next

        '選択されたフォルダのファイルを取得してリストビューに表示する
        For Each f As FileInfo In di.GetFiles()
            Dim fileItemx As New ListViewItem

            fileItemx.Text = f.Name
            ListView1.Items.Add(fileItemx)
        Next
    End Sub
End Class