﻿Public Class frm11_1

    ''' <summary>
    ''' [START]ボタンクリック時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        ' [START]ボタンを無効にする
        btnStart.Enabled = False

        '進捗状況の報告をできるようにする
        BackgroundWorker1.WorkerReportsProgress = True

        'バックグラウンド処理を開始する
        BackgroundWorker1.RunWorkerAsync()
    End Sub

    ''' <summary>
    ''' 時間のかかる処理を実行する
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        For I As Integer = 1 To 100
            '200mSecスリープさせる
            System.Threading.Thread.Sleep(200)

            'ProgressChangedイベントを発生させる
            BackgroundWorker1.ReportProgress(I)
        Next
    End Sub

    ''' <summary>
    ''' 進捗状況更新処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        'プログレスバーを進捗させる
        ProgressBar1.Value = e.ProgressPercentage
    End Sub

    ''' <summary>
    ''' バックグラウンド処理完了時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As System.Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        'バックグラウンド処理が完了したので[START]ボタンを有効にする
        btnStart.Enabled = True
    End Sub
End Class