﻿Public Class frm11_3
    ''' <summary>
    ''' [START]ボタンクリック時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        ' [START]ボタンを無効にする
        btnStart.Enabled = False

        '進捗状況の報告をできるようにする
        BackgroundWorker1.WorkerReportsProgress = True

        'バックグラウンド処理をキャンセルできるようにする
        BackgroundWorker1.WorkerSupportsCancellation = True

        'バックグラウンド処理を開始する
        BackgroundWorker1.RunWorkerAsync()
    End Sub

    ''' <summary>
    ''' [CANCEL]ボタンクリック時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        'バックグラウンド処理が実行中か？
        If BackgroundWorker1.IsBusy Then
            'バックグラウンド処理をキャンセルする
            BackgroundWorker1.CancelAsync()
        End If
    End Sub

    ''' <summary>
    ''' 時間のかかる処理を実行する
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        For I As Integer = 1 To 100
            'バックグラウンド操作のキャンセル要求が出されているかを確認する
            If BackgroundWorker1.CancellationPending = True Then
                'イベントをキャンセルする
                e.Cancel = True
                Return
            End If

            '200mSecスリープさせる
            System.Threading.Thread.Sleep(200)

            'ProgressChangedイベントを発生させる
            BackgroundWorker1.ReportProgress(I)
        Next
    End Sub

    ''' <summary>
    ''' 進捗状況更新処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        'プログレスバーを進捗させる
        ProgressBar1.Value = e.ProgressPercentage
    End Sub

    ''' <summary>
    ''' バックグラウンド処理完了時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As System.Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        'バックグラウンド操作がキャンセルされた場合
        If e.Cancelled = True Then
            'ボタンとプログレスバーを初期化する
            btnStart.Enabled = True
            btnCancel.Enabled = False
            ProgressBar1.Value = 0

            MessageBox.Show("キャンセルされました！！")
        End If

        'バックグラウンド処理が完了したので[START]ボタンを有効にする
        btnStart.Enabled = True
    End Sub
End Class