﻿Public Class frm12_4

    Private nCountPage As Integer = 0

    ''' <summary>
    ''' フォームロード時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub frm12_4_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'プレビュードキュメントの設定
        PrintPreviewControl1.Document = PrintDocument1

        'ズーム倍率の初期値設定
        PrintPreviewControl1.Zoom = 0.1

        '2行3列ページを1度にプレビューできるようにする
        PrintPreviewControl1.Rows = 2
        PrintPreviewControl1.Columns = 3

        'ページ番号の初期化
        nCountPage = 1
    End Sub

    ''' <summary>
    ''' 印刷処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim g As Graphics = e.Graphics
        Dim strPage As String

        '描画単位をミリメートルに設定
        g.PageUnit = GraphicsUnit.Millimeter

        strPage = nCountPage.ToString() & " / 6"

        '文字列を描画
        g.DrawString(strPage, New Font("MS ゴシック", 50, FontStyle.Bold Or FontStyle.Italic),
                     Brushes.Black, New Point(10, 10))

        If nCountPage < 6 Then
            '6ページまで印刷を行う
            e.HasMorePages = True
            nCountPage += 1
        Else
            'これ以上印刷しない
            e.HasMorePages = False
        End If
    End Sub

    ''' <summary>
    ''' ズーム変更時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        PrintPreviewControl1.Zoom = TrackBar1.Value / 10
    End Sub
End Class